import { ReactNode } from 'react';
import { UseListenToCustomEvent } from '../modules/useEventsModule';
import { UseSpringReturnType } from './useSpringCarousel.types';
export declare type SlideActionType = 'prev' | 'next' | 'initial';
export declare type SlideMode = 'drag' | 'click' | 'initial';
export declare type TransitionSlideMode = 'swipe' | 'click' | 'initial';
declare type SpringRenderItem = {
    useListenToCustomEvent: UseListenToCustomEvent<'use-spring'>['useListenToCustomEvent'];
    getIsActiveItem: UseSpringReturnType['getIsActiveItem'];
    getIsPrevItem: UseSpringReturnType['getIsPrevItem'];
    getIsNextItem: UseSpringReturnType['getIsNextItem'];
};
declare type TransitionRenderItem = {
    getIsPrevItem: UseSpringReturnType['getIsPrevItem'];
    getIsNextItem: UseSpringReturnType['getIsNextItem'];
    useListenToCustomEvent: UseListenToCustomEvent<'use-transition'>['useListenToCustomEvent'];
    activeItem: {
        index: number;
        id: string;
    };
};
export declare type RenderItemProps<T> = T extends 'use-spring' ? SpringRenderItem : TransitionRenderItem;
declare type RenderItemFn<T> = (props: RenderItemProps<T>) => JSX.Element;
export declare type ItemWithThumb<T extends 'use-spring' | 'use-transition'> = {
    id: string;
    renderItem: ReactNode | RenderItemFn<T>;
    renderThumb: ReactNode | RenderItemFn<T>;
};
export declare type ItemWithNoThumb<T extends 'use-spring' | 'use-transition'> = {
    id: string;
    renderItem: ReactNode | RenderItemFn<T>;
};
export declare type PrepareThumbsData<T extends 'use-spring' | 'use-transition'> = (items: Omit<ItemWithThumb<T>, 'renderItem'>[]) => Omit<ItemWithThumb<T>, 'renderItem'>[];
export {};
